/***************************************************************************
 *   Copyright (C) 2008 by defnax                                          *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <QFileInfo>

#include <QList>
#include <QtDebug>
#include <QContextMenuEvent>
#include <QMenu>
#include <QAction>
#include <QVBoxLayout>
#include <QIcon>
#include <QStandardItemModel>
#include <QModelIndex>
#include <QDir>
#include <QFileInfo>

#include <QContextMenuEvent>
#include <QMenu>
#include <QCursor>
#include <QPoint>
#include <QMouseEvent>
#include <QPixmap>
#include <QHeaderView>

#include "kommute.h"
#include "kommutedefs.h"
#include "connectionevent.h"
#include "connectioncountevent.h"
#include "connectionattemptevent.h"
#include "connect/ConnectDialog.h"
#include "download.h"
#include "uploadevent.h"
#include "uploadscountevent.h"
#include "uploadlistitem.h"
#include "uploadslist.h"
#include "kommuteutils.h"
#include "kommuteversion.h"
#include "mutelayer.h"


/** Constructor */
void Kommute::initConnectionsPage()
{
    /* Set header resize modes and initial section sizes */
	QHeaderView * _cheader = connectionsTreeView->header();
	_cheader->setResizeMode ( 0, QHeaderView::Custom);
    _cheader->resizeSection ( 0, 20 );
	_cheader->resizeSection ( 1, 100 );
	_cheader->resizeSection ( 2, 100 );
	_cheader->resizeSection ( 3, 100 );
	_cheader->resizeSection ( 4, 100 );
	_cheader->resizeSection ( 5, 100 );
    
     /* hide the Tree +/- 
    connectionsTreeView -> setRootIsDecorated( false );*/
  
	/* Set header resize modes and initial section sizes 
	QHeaderView * _header = connectionsTreeView->header () ;   
	_header->setResizeMode (0, QHeaderView::Interactive);
	_header->setResizeMode (1, QHeaderView::Interactive);
	_header->setResizeMode (2, QHeaderView::Interactive);
	_header->setResizeMode (3, QHeaderView::Interactive);
	_header->setResizeMode (4, QHeaderView::Interactive);
    
	_header->resizeSection ( 0, 100 );
	_header->resizeSection ( 1, 100 );
	_header->resizeSection ( 2, 100 );
	_header->resizeSection ( 3, 100 );
	_header->resizeSection ( 4, 100 );*/
	
	connect(infoLog, SIGNAL(customContextMenuRequested(const QPoint&)), this, SLOT(displayInfoLogMenu(const QPoint&)));
	connect(connectionsTreeView, SIGNAL( customContextMenuRequested( QPoint ) ), this, SLOT( connectionstreeViewCostumPopupMenu( QPoint ) ) );


	//char *virtualAddress = MuteLayer::getLocalVirtualAddress();
    //setLogInfo(tr("Host")+virtualAddress+"["+MuteLayer::getMnemonic( virtualAddress ) +"]");
	
	 // Set Log infos
    setLogInfo(tr("Kommute %1 started.", "e.g: Kommute v0.x started.").arg(kommuteVersion()));
     

  /* Hide platform specific features */
#ifdef Q_WS_WIN

#endif
}

void Kommute::connectionstreeViewCostumPopupMenu( QPoint point )
{

      QMenu contextMnu( this );
      QMouseEvent *mevent = new QMouseEvent( QEvent::MouseButtonPress, point, Qt::RightButton, Qt::RightButton, Qt::NoModifier );

	  addhostAct = new QAction(QIcon(), tr( "Add Host" ), this );
      connect( addhostAct , SIGNAL( triggered() ), this, SLOT( showConnectDialog() ) );
      

      contextMnu.clear();
      contextMnu.addAction( addhostAct);
	  //contextMnu.addSeparator();     

      contextMnu.exec( mevent->globalPos() );
}

/*
void ConnectionsPage::customEvent(QEvent *e)
{
    int c;
    QModelIndex index;

    bool found = false;
    switch(e->type())
    {
        case EVENTTYPE_CLEARCONNECTIONS:
	    c = ConnectionsListModel->rowCount();
	    ConnectionsListModel->removeRows(0,c);
            break;
        case EVENTTYPE_CONNECTION:
            c = ConnectionsListModel->rowCount();
            ConnectionsListModel->insertRow(c);
            index = ConnectionsListModel->index(c, 0);
            ConnectionsListModel->setData(index, QIcon(QString::fromUtf8(":/resources/connect_to_network.png")), Qt::DecorationRole);
            index = ConnectionsListModel->index(c, 1);
            ConnectionsListModel->setData(index, static_cast<ConnectionEvent*>(e)->address);
            index = ConnectionsListModel->index(c, 2);
            ConnectionsListModel->setData(index, static_cast<ConnectionEvent*>(e)->port);
            index = ConnectionsListModel->index(c, 3);
            ConnectionsListModel->setData(index, static_cast<ConnectionEvent*>(e)->sentCount);
            index = ConnectionsListModel->index(c, 4);
            ConnectionsListModel->setData(index, static_cast<ConnectionEvent*>(e)->queuedCount);
            index = ConnectionsListModel->index(c, 5);
            ConnectionsListModel->setData(index, static_cast<ConnectionEvent*>(e)->droppedCount);
            break;
        case EVENTTYPE_CONNECTIONCOUNT:
            emit connectionCountChanged(static_cast<ConnectionCountEvent*>(e)->connectionCount);
            break;
        case EVENTTYPE_CONNECTIONATTEMPT:
            emit currentConnectionAttempt(static_cast<ConnectionAttemptEvent*>(e)->attemptAddress,
                                          static_cast<ConnectionAttemptEvent*>(e)->attemptPort );
            break;
        default:
            break;
    }

}
*/

// Update Log Info information
void Kommute::setLogInfo(QString info, QColor color) {
  static unsigned int nbLines = 0;
  ++nbLines;
  // Check log size, clear it if too big
  if(nbLines > 200) {
    infoLog->clear();
    nbLines = 1;
  }
  infoLog->append(QString::fromUtf8("<font color='grey'>")+ QTime::currentTime().toString(QString::fromUtf8("hh:mm:ss")) + QString::fromUtf8("</font> - <font color='") + color.name() +QString::fromUtf8("'><i>") + info + QString::fromUtf8("</i></font>"));
}

void Kommute::on_actionClearLog_triggered() {
  infoLog->clear();
}

void Kommute::displayInfoLogMenu(const QPoint& pos) {
  // Log Menu
  QMenu myLogMenu(this);
  myLogMenu.addAction(actionClearLog);
  // XXX: Why mapToGlobal() is not enough?
  myLogMenu.exec(mapToGlobal(pos)+QPoint(20,450));
}

/** Shows Connect Dialog */
void Kommute::showConnectDialog()
{
    static ConnectDialog *connectdialog = new ConnectDialog();
    connectdialog->show();
}

void Kommute::showConnectionAttempt( QString attemptAddress, int attemptPort )
{
    setLogInfo( "Trying to connect to " + attemptAddress + ":" + QString::number( attemptPort ) + "...", 5000 );
}