/****************************************************************
 *  Kommute is distributed under the following license:
 *
 *  Copyright (C) 2008, defnax
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 *  Boston, MA  02110-1301, USA.
 ****************************************************************/

#include "kommute.h"
#include "sharedfileslist.h"
#include "SFListDelegate.h"

#include <QAction>
#include <QTreeView>
#include <QList>
#include <QtDebug>
#include <QContextMenuEvent>
#include <QMenu>
#include <QCursor>
#include <QPoint>
#include <QMouseEvent>
#include <QPixmap>
#include <QHeaderView>
#include <QModelIndex>
#include <QStandardItemModel>

/** Constructor */
void Kommute::initSharedFilesPage()
{
  
  
    SFListModel = new QStandardItemModel(0, 3);
    SFListModel->setHeaderData(SFNAME, Qt::Horizontal, tr("File Name"));
    SFListModel->setHeaderData(SFSIZE, Qt::Horizontal, tr("Size"));
    SFListModel->setHeaderData(SFHASH, Qt::Horizontal, tr("Hash"));
    
    sharedfilesTreeView->setModel(SFListModel);
    SFDelegate = new SFListDelegate(sharedfilesTreeView);
    sharedfilesTreeView->setItemDelegate(SFDelegate);
    
     //Selection Setup
	//selection = sharedfilesTreeView->selectionModel();
    
    sharedfilesTreeView->setSortingEnabled(true);
    sharedfilesTreeView->setRootIsDecorated(false);
    
    /* Set header resize modes and initial section sizes */
	QHeaderView * _sfheader = sharedfilesTreeView->header();
    _sfheader->resizeSection ( SFNAME, 270 );
	_sfheader->resizeSection ( SFSIZE, 75 );
	_sfheader->resizeSection ( SFHASH, 240 );


#if defined(Q_WS_WIN)

#endif
  
#if defined(Q_WS_X11)

#endif
}

int Kommute::addSFItem(QString sfsymbol, QString sfname, qlonglong sffileSize, QString sfhash)
{
	int row;
	//QIcon icon(sfsymbol);
	name.insert(0, " ");
	row = SFListModel->rowCount();
	SFListModel->insertRow(row);

	//SFListModel->setData(SFListModel->index(row, SFSYMBOL), QVariant((QIcon)icon), Qt::DecorationRole);
	SFListModel->setData(SFListModel->index(row, SFNAME), QVariant((QString)sfname), Qt::DisplayRole);
	SFListModel->setData(SFListModel->index(row, SFSIZE), QVariant((qlonglong)sffileSize));
    SFListModel->setData(SFListModel->index(row, SFHASH), QVariant((QString)sfhash));
	return row;
}

void Kommute::delSFItem(int row)
{
	SFListModel->removeRow(row, QModelIndex());
}

void Kommute::editSFItem(int row, int column, QVariant data)
{
	//QIcon *icon;
	switch(column) {
		//case SFSYMBOL:
			/*icon = new QIcon(data.toString());*/
			//SFListModel->setData(SFListModel->index(row, SFSYMBOL), QVariant((QIcon)*icon), Qt::DecorationRole);
			//delete icon;
			//break;
		case SFNAME:
			SFListModel->setData(SFListModel->index(row, SFNAME), data, Qt::DisplayRole);
			break;
		case SFSIZE:
			SFListModel->setData(SFListModel->index(row, SFSIZE), data);
			break;
		case SFHASH:
			SFListModel->setData(SFListModel->index(row, SFHASH), data);
			break;
	}
}


QString Kommute::getSFFileName(int row, QStandardItemModel *model)
{
	return model->data(model->index(row, SFNAME), Qt::DisplayRole).toString();
}

qlonglong Kommute::getSFFileSize(int row, QStandardItemModel *model)
{
	bool ok = false;
	return model->data(model->index(row, SFSIZE), Qt::DisplayRole).toULongLong(&ok);
}

QString Kommute::getSFHash(int row, QStandardItemModel *model)
{
	return model->data(model->index(row, SFHASH), Qt::DisplayRole).toString();
}
