/***************************************************************************
 *   Copyright (C) 2006 by Niels Sandholt Busch                            *
 *   niels@diku.dk                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DOWNLOADSTABLE_H
#define DOWNLOADSTABLE_H

#include <QTableView>
#include <QTreeView>
#include <QModelIndex>

class QContextMenuEvent;
class Download;

/**
@author Niels Sandholt Busch
*/
class DownloadsTable : public QTreeView
{
Q_OBJECT
public:
    DownloadsTable(QWidget *parent = 0);

    ~DownloadsTable();

    void contextMenuEvent( QContextMenuEvent* );
    void cancelAll();

signals:
    void downloadCanceled( qint64 );
    void grabFriendRequested(QString fname,
                             unsigned long fsize,
                             QString fhash,
                             QString fhost);

protected slots:
    void cancel();
    void download();
    void clear();
    void grab();

private:

};

#endif
