/***************************************************************************
 *   Copyright (C) 2005 by Niels Sandholt Busch                            *
 *   niels@diku.dk                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DOWNLOADTHREAD_H
#define DOWNLOADTHREAD_H

#include <QThread>
#include <QMutex>

/**
@author Niels Sandholt Busch
*/
class DownloadThread : public QThread
{
public:
    DownloadThread(QObject *eventReceiver,
                   QString fname,
                   QString fhost,
                   QString fhash);

    ~DownloadThread();

    virtual void run();

    void dequeue();
    void stop();

private:
    char downloadHandler( unsigned char *inChunk,
                          int inChunkLengthInBytes, int inChunkNumber );
    static char muteDownloadHandler( unsigned char *inChunk, 
                                     int inChunkLengthInBytes, int inChunkNumber,
                                     void *inExtraParam );

    bool openSaveFile();
    QString getFilenameWithoutPath();
    QString getIncomingDirectory();
    bool validateIncomingDirectory();
    QString getIncomingPath();
    QString getCompletedPath();
    bool moveCompleted();

    bool running,forceDequeue;
    QObject *eventReceiver;
    QString filename, host, filehash;
    int finalSize, currentSize, downloadId;
    FILE *saveFile;
    char  * partialFilePath;
    QMutex mutex;
};

#endif
