/***************************************************************************
 *   Copyright (C) 2007 kommute team                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HASHTHREAD_H
#define HASHTHREAD_H

#include "minorGems/crypto/hashes/sha1.h"
#include "minorGems/io/file/File.h"
#include <QThread>
#include <QTime>

typedef struct sharehash
{
  char *name;
  char *hash;
  qint64 size;
  QDateTime *time;
} SHASH;

class HashThread : public QThread
{
public:
    HashThread( QObject *eventReceiver);

    ~HashThread();

    virtual void run();
    void stop();


private:
    bool running;
    QObject *eventReceiver;
    void doHash();
    void loadHash();
    void doPost (SHASH * share);
    QTime time0;
};

#endif
