;Name "Kommute"
!include Library.nsh

; Define your application name
!define APPNAME "Kommute"
!define VERSION "0.12-1"
!define APPNAMEANDVERSION "${APPNAME} ${VERSION}"

; Main Install settings
Name "${APPNAMEANDVERSION}"
InstallDir "$PROGRAMFILES\Kommute"
InstallDirRegKey HKLM "Software\${APPNAME}" "Install_Dir"
OutFile "kommute-${VERSION}.exe"
BrandingText "${APPNAMEANDVERSION}"


;--------------------------------

; Modern interface settings
!include Sections.nsh
!include "MUI.nsh"


;Interface Settings
!define MUI_ABORTWARNING

# MUI defines
;!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install-blue.ico"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_LICENSEPAGE_RADIOBUTTONS
!define MUI_COMPONENTSPAGE_SMALLDESC
!define MUI_FINISHPAGE_LINK "Visit the Kommute forum for the latest news and support"
!define MUI_FINISHPAGE_LINK_LOCATION "http://sourceforge.net/forum/forum.php?forum_id=491250"
!define MUI_FINISHPAGE_RUN "$INSTDIR\Kommute.exe"
!define MUI_FINISHPAGE_SHOWREADME $INSTDIR\changelog.txt
!define MUI_FINISHPAGE_SHOWREADME_TEXT changelog.txt
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
;!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall-blue.ico"
!define MUI_UNFINISHPAGE_NOAUTOCLOSE
!define MUI_LANGDLL_REGISTRY_ROOT HKLM
!define MUI_LANGDLL_REGISTRY_KEY ${REGKEY}
!define MUI_LANGDLL_REGISTRY_VALUENAME InstallerLanguage

;--------------------------------
;Configuration


  ;!insertmacro MUI_RESERVEFILE_SPECIALBITMAP
 
  LicenseLangString myLicenseData 1033 "license\license.txt"
  LicenseLangString myLicenseData 1031 "license\license-GER.txt"
  LicenseLangString myLicenseData 1036 "license\license-FR.txt"
  LicenseLangString myLicenseData 1055 "license\license-TR.txt"

  LicenseData $(myLicenseData)

# Installer pages
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "$(myLicenseData)"
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

# Installer languages
!define MUI_LANGDLL_ALLLANGUAGES

!insertmacro MUI_LANGUAGE English
!insertmacro MUI_LANGUAGE German
!insertmacro MUI_LANGUAGE French
!insertmacro MUI_LANGUAGE Turkish
  ;Component-selection page
    ;Titles
    
    LangString sec_kommute ${LANG_ENGLISH} "Kommute (required)"
    LangString sec_startmenu ${LANG_ENGLISH} "Start Menu Shortcuts"
    LangString sec_shortcuts ${LANG_ENGLISH} "Shortcuts"
    LangString DESC_sec_kommute ${LANG_ENGLISH} "Installs the Kommute program files."
    LangString DESC_sec_startmenu ${LANG_ENGLISH} "Create Start Menu Shortcuts"
    LangString DESC_sec_shortcuts ${LANG_ENGLISH} "Create Kommute shortcut icons."
    LangString LANGUAGEID ${LANG_ENGLISH} "1033"

    
    LangString sec_kommute ${LANG_GERMAN} "Kommute  Programmdateien(erforderlich)"
    LangString sec_startmenu ${LANG_GERMAN} "Start Menu Verknpfung"
    LangString sec_shortcuts ${LANG_GERMAN} "Shortcuts"
	LangString DESC_sec_kommute ${LANG_GERMAN} "Installiert die erforderlichen Programmdateien."
	LangString DESC_sec_startmenu ${LANG_GERMAN} "Erstellt eine Start Menu Verknpfung"
    LangString DESC_sec_shortcuts ${LANG_GERMAN} "Erstellt eine Kommute Verknpfung als Desktop und/oder Schnellstart Icon."
    LangString LANGUAGEID ${LANG_GERMAN} "1031"

    LangString sec_kommute ${LANG_FRENCH} "Kommute (obligatoire)"
    LangString sec_startmenu ${LANG_FRENCH} "Raccourcis du menu Dmarrer"
    LangString sec_shortcuts ${LANG_FRENCH} "Raccourcis"
    LangString DESC_sec_kommute ${LANG_FRENCH} "Installe les fichiers du programme."
    LangString DESC_sec_startmenu ${LANG_FRENCH} "Cre les raccourcis du menu Dmarrer"
    LangString DESC_sec_shortcuts ${LANG_FRENCH} "Cre une icne sur le bureau."
    LangString LANGUAGEID ${LANG_FRENCH} "1036"
    
    LangString sec_kommute ${LANG_TURKISH} "Kommute Program Dosyalar"
    LangString sec_startmenu ${LANG_TURKISH} "Start Menu"
    LangString sec_shortcuts ${LANG_TURKISH} "Shortcut'lar"
	LangString DESC_sec_kommute ${LANG_TURKISH} "Program dosyalarn kurar."
	LangString DESC_sec_startmenu ${LANG_TURKISH} "Start Menu Shortcut yap"
    LangString DESC_sec_shortcuts ${TURKISH} "Shortcut yap Start menu , Desktop veya Quicklaunchbar"
    LangString LANGUAGEID ${LANG_TURKISH} "1055"


; The stuff to install
Section $(sec_kommute) sec_kommute


  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there

  File /oname=$INSTDIR\kommute.exe "release\kommute.exe" 

  File /r "doc"
  File /r "*.qm"
  File /r "changelog.txt"


!insertmacro InstallLib DLL NOTSHARED NOREBOOT_PROTECTED "d:\mingw\bin\mingwm10.dll" $SYSDIR\mingwm10.dll $SYSDIR
!insertmacro InstallLib DLL NOTSHARED NOREBOOT_PROTECTED d:\qt\4.3.1\bin\QtCore4.dll $SYSDIR\QtCore4.dll $SYSDIR
!insertmacro InstallLib DLL NOTSHARED NOREBOOT_PROTECTED d:\qt\4.3.1\bin\QtGui4.dll $SYSDIR\QtGui4.dll $SYSDIR
!insertmacro InstallLib DLL NOTSHARED NOREBOOT_PROTECTED d:\qt\4.3.1\bin\QtNetwork4.dll $SYSDIR\QtNetwork4.dll $SYSDIR

  
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\Kommute "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kommute" "DisplayName" "Kommute"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kommute" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kommute" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kommute" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section $(sec_startmenu) sec_startmenu

  CreateDirectory "$SMPROGRAMS\Kommute"
  CreateShortCut "$SMPROGRAMS\Kommute\$(^UninstallLink).lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Kommute\Kommute.lnk" "$INSTDIR\Kommute.exe" "" "$INSTDIR\Kommute.exe" 0
  
SectionEnd

SectionGroup $(sec_shortcuts) sec_shortcuts
Section Desktop SEC0001

  CreateShortCut "$DESKTOP\Kommute.lnk" "$INSTDIR\Kommute.exe" "" "$INSTDIR\Kommute.exe" 0
  
SectionEnd

Section Quicklaunchbar SEC0002
  

  CreateShortCut "$QUICKLAUNCH\Kommute.lnk" "$INSTDIR\Kommute.exe" "" "$INSTDIR\Kommute.exe" 0
  
SectionEnd
SectionGroupEnd   

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${sec_kommute} $(DESC_sec_kommute)
    !insertmacro MUI_DESCRIPTION_TEXT ${sec_startmenu} $(DESC_sec_startmenu)
    !insertmacro MUI_DESCRIPTION_TEXT ${sec_shortcuts} $(DESC_sec_shortcuts)
!insertmacro MUI_FUNCTION_DESCRIPTION_END     

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kommute"
  DeleteRegKey HKLM SOFTWARE\Kommute

  ; Remove files and uninstaller
  Delete $INSTDIR\Kommute.exe
  Delete $INSTDIR\MUTE.log
  RMDir /r $INSTDIR\doc
  RMDir /r $INSTDIR\translations
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Kommute\*.*"
  ; Remove desktop shortcut 
  Delete "$DESKTOP\Kommute.lnk"
  ; Remove Quicklaunch shortcut 
  Delete "$QUICKLAUNCH\Kommute.lnk"

  ; Remove directories used
  RMDir "$SMPROGRAMS\Kommute"
  RMDir "$INSTDIR"

SectionEnd

Function .onInit

    !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd

# Installer Language Strings
# TODO Update the Language Strings with the appropriate translations.

LangString ^UninstallLink ${LANG_ENGLISH} "Uninstall"
LangString ^UninstallLink ${LANG_GERMAN} "Deinstallieren"
LangString ^UninstallLink ${LANG_FRENCH} "Dsinstaller"
LangString ^UninstallLink ${LANG_TURKISH} "Kaldr"
