/***************************************************************************
 *   Copyright (C) 2005 by Niels Sandholt Busch   *
 *   niels@diku.dk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KOMMUTEDEFS_H
#define KOMMUTEDEFS_H

// Custom event types
#define EVENTTYPE_SEARCHRESULT (QEvent::Type) (QEvent::User + 1)
#define EVENTTYPE_DOWNLOADFILE (QEvent::Type) (QEvent::User + 2)
#define EVENTTYPE_DOWNLOADSTATUS (QEvent::Type) (QEvent::User + 3)
#define EVENTTYPE_CONNECTION (QEvent::Type) (QEvent::User + 4)
#define EVENTTYPE_CONNECTIONCOUNT (QEvent::Type) (QEvent::User + 5)
#define EVENTTYPE_UPLOAD (QEvent::Type) (QEvent::User + 6)
#define EVENTTYPE_UPLOADSCOUNT (QEvent::Type) (QEvent::User + 7)
#define EVENTTYPE_CONNECTIONATTEMPT (QEvent::Type)(QEvent::User + 8)
#define EVENTTYPE_CLEARCONNECTIONS (QEvent::Type) (QEvent::User + 9)
#define EVENTTYPE_SHAREDFILES (QEvent::Type) (QEvent::User + 10)

// Download status
#define DOWNLOADSTATUS_CONNECTING 0
#define DOWNLOADSTATUS_DOWNLOADING 1
#define DOWNLOADSTATUS_FILENOTFOUND 2
#define DOWNLOADSTATUS_FILETRANSFERFAILED 3
#define DOWNLOADSTATUS_FILETRANSFERCANCELED 4
#define DOWNLOADSTATUS_FILETRANSFERCOMPLETE 5
#define DOWNLOADSTATUS_FILETRANSFERHASHMISMATCH 6
#define DOWNLOADSTATUS_QUEUED 7
#define DOWNLOADSTATUS_DEQUEUED 8
#define DOWNLOADSTATUS_DELAYED 9
#define DOWNLOADSTATUS_UNKNOWN 10
#define DOWNLOADSTATUS_TIMED_OUT_WILL_RETRY 11
#define DOWNLOADSTATUS_WAITING_FOR_SOURCES 12
#define DOWNLOADSTATUS_STARTING 13
#define DOWNLOADSTATUS_FETCHING_INFO 14

// Upload status
#define UPLOADSTATUS_DONE 0
#define UPLOADSTATUS_FAILED 1
#define UPLOADSTATUS_STALLED 2
#define UPLOADSTATUS_STARTING 3
#define UPLOADSTATUS_UPLOADING 4

#endif
