/***************************************************************************
 *   Copyright (C) 2005 by Niels Sandholt Busch                            *
 *   niels@diku.dk                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "numberofconnections.h"

#include "mutelayer.h"

#include <QLayout>
#include <QLabel>
#include <QIcon>
#include <QPainter>
#include <QPixmap>

NumberofConnections::NumberofConnections(QWidget *parent)
 : QWidget(parent), numbConnections(0)
{
    QHBoxLayout *hbox = new QHBoxLayout();
    hbox->setMargin(0);
    hbox->setSpacing(6);
    
    conniconLabel = new QLabel( this );
    conniconLabel->setPixmap(QPixmap::QPixmap(":/resources/connections16.png"));
    // iconLabel doesn't change over time, so we didn't need a minimum size
    hbox->addWidget(conniconLabel);
    //dLabel = new QLabel( tr(":") + "", this );
    // connQualLabel doesn't change over time, so we didn't need a minimum size
    //hbox->addWidget(dLabel);
    numberLabel = new QLabel( tr("0"), this );
    /* progressLabel changes over time, so we need to define a minimum size
       We set the minimum size to the tr("Not Connected") size, because in some 
       languages this might be larger than in english.
    */
    numberLabel->setMinimumSize( numberLabel->frameSize().width() + 2, 4 );
    hbox->addWidget(numberLabel);
    
    setLayout( hbox );
}

NumberofConnections::~NumberofConnections()
{
}

void NumberofConnections::setNumber( int numprogress )
{
    numbConnections = numprogress;

    if( 0 == numprogress )
    {
        numberLabel->setText(tr("0"));

        return;
    }

    int totalSteps = MuteLayer::muteLayerGetTargetNumberOfConnections();
    float p = static_cast<float>(numprogress) / static_cast<float>(totalSteps);

    if( p > 2.5 )
    {
        numberLabel->setText(tr("11"));
    }
    else if( p > 2.25 )
    {
        numberLabel->setText(tr("10"));
    }
    else if( p > 2.00 )
    {
        numberLabel->setText(tr("9"));
    }
    else if( p > 1.75 )
    {
        numberLabel->setText(tr("8"));
    }
    else if( p > 1.5 )
    {
        numberLabel->setText(tr("7"));
    }
    else if( p > 1.25 )
    {
        numberLabel->setText(tr("6"));
    }
    else if( p > 1.0 )
    {
        numberLabel->setText(tr("5"));
    }
    else if( p > 0.75 )
    {
        numberLabel->setText(tr("4"));
    }
    else if( p > 0.5 )
    {
        numberLabel->setText(tr("3"));
    }
    else if( p > 0.25 )
    {
        numberLabel->setText(tr("2"));
    }
    else
    {
        numberLabel->setText(tr("1"));
    }
}

