/***************************************************************************
 *   Copyright (C) 2006 by Niels Sandholt Busch                            *
 *   niels@diku.dk                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "sharedfileslist.h"
#include "properities/CommentsDialog.h"

#include <QContextMenuEvent>
#include <QMenu>
#include <QAction>
#include <QTreeView>
#include <QHeaderView>

SharedFilesList::SharedFilesList (QWidget * parent):QTreeView (parent)
{

}

SharedFilesList::~SharedFilesList ()
{
}

void
SharedFilesList::contextMenuEvent (QContextMenuEvent * e)
{
  QMenu popMenu (this);
  QAction *actionOpenfile = popMenu.addAction (tr ("Open File"));
  actionOpenfile->setIcon (QIcon (":/resources/fileopen.png"));
  //connect (actionOpenfile, SIGNAL (triggered ()), this, SLOT (openfile ()));
  
  QAction *actionOpenfolder = popMenu.addAction (tr ("Open Folder"));
  actionOpenfolder->setIcon (QIcon (":/resources/folderopen.png"));
  //connect (actionOpenfolder, SIGNAL (triggered ()), this, SLOT (openfolder ()));
  
  popMenu.addSeparator ();
  
  QAction *actionComments = popMenu.addAction (tr ("Comments..."));
  actionComments->setIcon (QIcon (":/resources/filecomments.png"));
  connect (actionComments, SIGNAL (triggered ()), this, SLOT (showcommentsdialog ()));
 


  popMenu.setMouseTracking (true);
  popMenu.exec (QCursor::pos ());
}

/*
void SharedFilesList::openfile()
{

}

void SharedFilesList::openfolder()
{

}*/

void SharedFilesList::showcommentsdialog()
{
    static CommentsDialog *commentsdlg = new CommentsDialog();
    commentsdlg->show();
}
