/***************************************************************************
 *   Copyright (C) 2006 by Niels Sandholt Busch                            *
 *   niels@diku.dk                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WEBHOSTCACHESDOWNLOAD_H
#define WEBHOSTCACHESDOWNLOAD_H

#define DEBUG

#include <QStringList>
#include <QBuffer>
#include <QHttp>
#include <QThread>
#include <QSemaphore>

/**
@author Andy Gebauer - feivelda@googlemail.com
*/

class WebHostCachesDownload : public QThread
{
    Q_OBJECT
    
public:
    WebHostCachesDownload( QStringList oldData, QStringList downloadLocations );
    ~WebHostCachesDownload();
    
    void run();
    bool isDownloading();
    
    QStringList getWebHostCaches();
    
private slots:
    void httpRequestFinished( int ID, bool error );
    
private:
    QStringList webHostCachesList;
    QStringList list;
    QHttp *http;
    QByteArray *byteArray;
    QBuffer *buffer;
    QSemaphore *semaphore;
    int downloadID;
    
    // for debugging
    #ifdef DEBUG
    int standardListCount;
    int listCount;
    #endif
    
    void download(QString file);
    void parseBuffer();
    void prepareList( QStringList oldData );
    void sortList();
};

#endif
